/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drp@ezeedsl.co.uk                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef AUDIOPLAYER_H
#define AUDIOPLAYER_H

#include <map>
#include <string>
#include <vector>

class Surface;
class Font;
class Colour;
class Music;

class AudioPlayer
{
public:
    enum PlayerState { STOPPED, PLAYING };

    AudioPlayer();
    void Render ( Surface& s, const Font& f, const Colour &fg, const Colour &bg, const Colour &hl );
    bool AddFile ( std::string fn );
    void Start();
    void Stop();
    void ToggleState();
    void NextFile();
    void PreviousFile();
    void VolumeUp();
    void VolumeDown();
    void SetVolume ( int v );
    int GetVolume();
    void RemoveFile();

protected:
    void Play ( Music* sound );
    void MusicFinished();
    static void SMusicFinished();
    static AudioPlayer* instance;
    std::vector<Music*> play_list;
    int current_file;
    PlayerState state;
    int volume;
};

#endif // AUDIOPLAYER_H
