/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drp@ezeedsl.co.uk                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef COLOUR_H
#define COLOUR_H

#include <SDL.h>

class Surface;


/**
 	Colour class
*/
class Colour
{
public:
    // Default colour none (transparent)
    Colour();

    // From pixel
    Colour ( unsigned short );

    // Set to RGB
    Colour ( const Surface& s, Uint8 r, Uint8 g, Uint8 b );

    // Get pixel value
    Uint32 Get ( void ) const;
    SDL_Color SGet ( void ) const;

    // Colour none - transparent
    static const Colour NONE;

    // Compare colours
    bool operator== ( const Colour& c ) const
    {
        return ( Get() == c.Get() );
    }
    bool operator!= ( const Colour& c ) const
    {
        return ( Get() != c.Get() );
    }

    // Assignment
    Colour& operator= ( const Colour& c )
    {
        colour = c.colour;
        return *this;
    }

private:
    // Pixel colour
    Uint32 colour;
    SDL_Colour scolour;
};

#endif // COLOUR_H
