/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drp@ezeedsl.co.uk                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SCREEN_H
#define SCREEN_H
#include <string>
#include <SDL.h>
#include "surface.h"

class Colour;

/**
	Screen handler class
*/
class Screen : public Surface
{

public:
    // Construct 16 bit colour screen of given size
    Screen ( int w, int h );


    // Lock screen
    void  Lock ( void );

    // Unlock screen
    void  Unlock ( void );

    // Update whole screen
    void  Update ( void );

    // Accessor Methods
    /**
     * Accessor for SDL_Surface
     * @param
     * @return SDL_Surface
     */
    SDL_Surface* get_screen ( void ) const;

};
#endif //SCREEN_H

