/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drp@ezeedsl.co.uk                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SOUND_H
#define SOUND_H

#include <string>
#include <SDL.h>
#include <SDL_mixer.h>

/**
 	Sound class
*/
class Sound
{
public:
    // Load sound file
    Sound ( std::string fn );
    virtual ~Sound();

    // Play sound
    int Play();

    // Volume controls
    void SetVolume ( int v );
    void VolumeUp();
    void VolumeDown();
    int GetVolume();
    std::string GetFile();
    bool IsValid();

protected:
    // Sound data
    Mix_Chunk* chunk;
    int volume;
    std::string file;
    bool valid;
};

#endif // SOUND_H
