/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drp@ezeedsl.co.uk                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SURFACE_H
#define SURFACE_H

#include <SDL.h>
#include "colour.h"

/**
	Abstraction of an SDL_Surface - 16 bit depth
*/
class Surface
{
public:
    Surface();

    ~Surface();

    void PutPixel ( int x, int y, const Colour& c );

    // Draw a rectangle
    void Rect ( int x, int y, int w, int h, const Colour& c );
    unsigned short GetPixel ( int x, int y );

    // Return pixel format
    SDL_PixelFormat* Format ( void ) const;

    // Blit to screen at x,y
    void Put ( Surface& dest, int x, int y );

    // Blit to screen at x,y blended
    void PutBlended ( Surface& dest, int x, int y, const Colour& transparent );

    SDL_Surface* GetSurface();

    void SetSurface ( SDL_Surface* theValue );

    int GetWidth ( void ) const
    {
        return surface->w;
    }
    int GetHeight ( void ) const
    {
        return surface->h;
    }


protected:
    SDL_Surface* surface;
};

#endif
