/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drp@ezeedsl.co.uk                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CHESSCONFIG_H
#define CHESSCONFIG_H

#include <string>
#include <map>

/**
*	Configuration manager
*/
class ChessConfig
{
public:
    ChessConfig();
    ~ChessConfig();
    void LoadFile ( const std::string& fn );
    void SaveFile();
    bool GetValue ( const std::string& n, int& v );
    bool GetValue ( const std::string& n, std::string& v );
    void SetValue ( const std::string& n, int v );
    void SetValue ( const std::string& n, const std::string& v );

protected:
    std::string file_name;
    std::map<std::string, std::string> values;
};

#endif
